program demoGradient;

{$COPERATORS ON}
{$APPTYPE GUI}

uses
	SDL,
	SDLGradient;
	
const
	demoGradientColor:t4Colors=(
		$FF0000FF,
		$00FF00FF,
		$0000FFFF,
		$FFFFFFFF
	);	
	
var
	screen:pSDL_SURFACE;
	SDLTestEvent:pSDL_EVENT;
	
procedure showGradient;
var
	gradient:pSDL_SURFACE;
	gradientRect,screenRect:pSDL_RECT;
begin
	gradient:=SDL_Gradient(512,512,demoGradientColor);
	new(gradientRect);
	with gradientRect^ do begin
		x:=0;
		y:=0;
		w:=512;
		h:=512;
	end;
	new(screenRect);
	with screenRect^ do begin
		x:=0;
		y:=0;
		w:=512;
		h:=512;
	end;
	SDL_BLITSURFACE(gradient,gradientRect,screen,screenRect);
  SDL_FLIP(screen);
  dispose(screenRect);
  dispose(gradientRect);
  SDL_FREESURFACE(gradient);
end;

function SDL_poll:boolean;
var
	windowEnd:boolean;
begin
	windowEnd:=false;
	if SDL_pollEvent(SDLTestEvent)=1 then begin
		case SDLTestEvent^.type_ of
			SDL_KEYDOWN:begin
				if (SDLTestEvent^.key.keysym.sym=SDLK_ESCAPE) then begin
					windowEnd:=true;
				end;
			end;
			SDL_QUITEV:begin
				windowEnd:=true;
			end;
		end;
	end;
	SDL_poll:=windowEnd;
end;

begin
	SDL_INIT(SDL_INIT_VIDEO);
	screen:=SDL_SETVIDEOMODE(512,512,32,SDL_SWSURFACE);
	if screen=nil then begin
		writeln('Failed to initialize SDL video');
	end else begin
		showGradient;
		new(SDLTestEvent);
		repeat until SDL_poll;
		SDL_FREESURFACE(screen);
		SDL_QUIT;
	end;
end.